Fixed merge issue with TIMESTAMP string printing twice.
[xfstests-dev.git] / common.config
1 ##/bin/sh
2 #
3 # Copyright (c) 2000-2003 Silicon Graphics, Inc.  All Rights Reserved.
4
5 # This program is free software; you can redistribute it and/or modify it
6 # under the terms of version 2 of the GNU General Public License as
7 # published by the Free Software Foundation.
8
9 # This program is distributed in the hope that it would be useful, but
10 # WITHOUT ANY WARRANTY; without even the implied warranty of
11 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
12
13 # Further, this software is distributed without any warranty that it is
14 # free of the rightful claim of any third person regarding infringement
15 # or the like.  Any license provided herein, whether implied or
16 # otherwise, applies only to this software file.  Patent licenses, if
17 # any, provided herein do not apply to combinations of this program with
18 # other software, or any other product whatsoever.
19
20 # You should have received a copy of the GNU General Public License along
21 # with this program; if not, write the Free Software Foundation, Inc., 59
22 # Temple Place - Suite 330, Boston MA 02111-1307, USA.
23
24 # Contact information: Silicon Graphics, Inc., 1600 Amphitheatre Pkwy,
25 # Mountain View, CA  94043, or:
26
27 # http://www.sgi.com 
28
29 # For further information regarding this notice, see: 
30
31 # http://oss.sgi.com/projects/GenInfo/SGIGPLNoticeExplan/
32 #
33
34 #
35 # setup and check for config parameters, and in particular
36 #
37 # TEST_DIR              - scratch test directory that is in an already
38 #                         mounted XFS file system, needs to be be world
39 #                         writeable
40 # TEST_DEV              - device for file system containing TEST_DIR
41 # SCRATCH_DEV           - device you can make a scratch file system on
42 # SCRATCH_MNT           - mount point for scratch file system
43
44 # and optionally:
45 # SCRATCH_LOGDEV        - scratch log device for external log testing
46 # SCRATCH_RTDEV         - scratch rt dev
47 # TEST_LOGDEV           - test log device for external log testing
48 # TEST_RTDEV            - test rt dev
49 # TAPE_DEV              - the tape device for the xfsdump tests
50 # RMT_TAPE_DEV          - the remote tape device for the xfsdump tests
51 # RMT_IRIXTAPE_DEV      - the IRIX remote tape device for the xfsdump tests
52 # RMT_TAPE_USER         - remote user for tape device
53 #
54 # - These can be added to known_hosts() below or a separate local
55 #   configuration file can be used (using the HOST_OPTIONS variable).
56 # - This script is shared by the stress test system and the auto-qa
57 #   system (includes both regression test and benchmark components).
58 # - TEST_DEV & TEST_DIR must be assigned.
59 # - this script shouldn't make any assertions about filesystem
60 #   validity or mountedness.
61 #
62
63 # Warning: don't put freeware before /usr/bsd on IRIX coz you'll
64 #          get the wrong hostname and set your system name to -s  :)
65 [ -d /usr/bsd ] && PATH=$PATH:/usr/bsd
66 [ -d /usr/freeware/bin ] && PATH=$PATH:/usr/freeware/bin
67 PATH=".:$PATH"
68
69 HOST=`hostname -s`
70 HOSTOS=`uname -s`
71 [ "$HOSTOS" = "IRIX64" ] && HOSTOS="IRIX"
72
73 MODULAR=0               # using XFS as a module or not
74 BOOT="/boot"            # install target for kernels
75 export EXTRA=${EXTRA:=xfs-qa}
76
77 # general parameters (mainly for auto-qa)
78 SOAK_PROC=3             # -p option to fsstress
79 SOAK_STRESS=10000       # -n option to fsstress
80 SOAK_PASSES=-1          # count of repetitions of fsstress (while soaking)
81 EMAIL=root@localhost    # where auto-qa will send its status messages
82 export HOST_OPTIONS=${HOST_OPTIONS:=local.config}
83 export CHECK_OPTIONS=${CHECK_OPTIONS:="-g auto"}
84 export BENCH_PASSES=${BENCH_PASSES:=5}
85 export XFS_MKFS_OPTIONS=${XFS_MKFS_OPTIONS:=-bsize=4096}
86
87 #export DEBUG=${DEBUG:=...} # arbitrary CFLAGS really.
88 export MALLOCLIB=${MALLOCLIB:=/usr/lib/libefence.a}
89 export LOCAL_CONFIGURE_OPTIONS=${LOCAL_CONFIGURE_OPTIONS:=--enable-readline=yes}
90
91 # $1 = prog to look for, $2* = default pathnames if not found in $PATH
92 set_prog_path()
93 {
94     p=`which $1 2> /dev/null`
95     if [ -n "$p" -a -x "$p" ]
96     then
97         echo $p
98         return 0
99     fi
100     p=$1
101
102     shift
103     for f
104     do
105         if [ -x $f ]
106         then
107             echo $f
108             return 0
109         fi
110     done
111
112     echo ""
113     return 1
114 }
115
116 _fatal()
117 {
118     echo "$*"
119     status=1
120     exit 1
121 }
122
123 export MKFS_PROG="`set_prog_path mkfs`"
124 [ "$MKFS_PROG" = "" ] && _fatal "mkfs not found"
125
126 export AWK_PROG="`set_prog_path awk`"
127 [ "$AWK_PROG" = "" ] && _fatal "awk not found"
128
129 export MOUNT_PROG="`set_prog_path mount`"
130 [ "$MOUNT_PROG" = "" ] && _fatal "mount not found"
131
132 export UMOUNT_PROG="`set_prog_path umount`"
133 [ "$UMOUNT_PROG" = "" ] && _fatal "umount not found"
134
135 export NSLOOKUP_PROG="`set_prog_path nslookup`"
136 [ "$NSLOOKUP_PROG" = "" ] && _fatal "nslookup not found"
137
138 export PERL_PROG="`set_prog_path perl`"
139 [ "$PERL_PROG" = "" ] && _fatal "perl not found"
140
141 export SED_PROG="`set_prog_path sed`"
142 [ "$SED_PROG" = "" ] && _fatal "sed not found"
143
144 export MAKE_PROG="`set_prog_path gmake`"
145 [ "$MAKE_PROG" = "" ] && _fatal "gmake not found"
146
147 export PS_ALL_FLAGS="-ef"
148
149 export DF_PROG="`set_prog_path df`"
150 [ "$DF_PROG" = "" ] && _fatal "df not found"
151 [ "$HOSTOS" = "Linux" ] && export DF_PROG="$DF_PROG -T"
152
153 export XFS_LOGPRINT_PROG="`set_prog_path xfs_logprint`"
154 export XFS_REPAIR_PROG="`set_prog_path xfs_repair`"
155 export XFS_CHECK_PROG="`set_prog_path xfs_check`"
156 export XFS_DB_PROG="`set_prog_path xfs_db`"
157
158 case "$HOSTOS" in
159     IRIX*)
160            export MKFS_XFS_PROG="`set_prog_path mkfs_xfs`"
161            export MKFS_UDF_PROG="`set_prog_path mkfs_udf`" 
162            export XFS_FSR_PROG="`set_prog_path /usr/etc/fsr_xfs`"
163            export MKFS_NFS_PROG="false" 
164            ;;
165     Linux)
166            export MKFS_XFS_PROG="`set_prog_path mkfs.xfs`"
167            export MKFS_UDF_PROG="`set_prog_path mkfs.udf`"
168            export XFS_FSR_PROG="`set_prog_path xfs_fsr`"
169            export MKFS_NFS_PROG="false" 
170            ;;
171 esac
172
173 known_hosts()
174 {
175         case "$HOST"
176         in
177             bruce)
178                 MODULAR=0
179                 EMAIL="nathans@larry"
180                 SCRATCH_MNT=/mnt/xfs0
181                 SCRATCH_DEV=/dev/sdb5
182                 SCRATCH_LOGDEV=/dev/sda11
183                 TEST_DIR=/mnt/xfs1
184                 TEST_DEV=/dev/sdc3
185                 TEST_LOGDEV=/dev/sda9
186                 TAPE_DEV=/dev/st0
187                 RMT_TAPE_DEV=bruce:/dev/st0
188                 RMT_IRIXTAPE_DEV=snort:/dev/tape
189                 RMT_TAPE_USER=guest
190                 ;;
191             sherman)
192                 TEST_DEV=/dev/sda10
193                 TEST_DIR=/mnt/xfs1
194                 SCRATCH_DEV=/dev/sda9
195                 SCRATCH_MNT=/mnt/xfs0
196                 ;;
197             flutz)
198                 MODULAR=0
199                 EMAIL="nathans@larry"
200                 TEST_DEV=/dev/sda5
201                 TEST_LOGDEV=/dev/sda9
202                 TEST_DIR=/xfsqa1
203                 SCRATCH_DEV=/dev/sda6
204                 SCRATCH_LOGDEV=/dev/sda7
205                 SCRATCH_MNT=/xfsqa2
206                 TAPE_DEV=/dev/st0
207                 RMT_TAPE_DEV=bruce:/dev/st0
208                 RMT_IRIXTAPE_DEV=snort:/dev/tape
209                 RMT_TAPE_USER=guest
210                 ;;
211             frodo)
212                 MODULAR=0
213                 EMAIL="nathans@larry"
214                 TEST_DEV=/dev/hda6
215                 TEST_DIR=/mnt/test
216                 SCRATCH_DEV=/dev/hda7
217                 SCRATCH_MNT=/mnt/scratch
218                 SCRATCH_LOGDEV=/dev/hda9
219                 ;;
220             goldfish)
221                 MODULAR=0
222                 TEST_DEV=/dev/hdc1
223                 TEST_DIR=/mnt/xfs0
224                 SCRATCH_DEV=/dev/hdc2
225                 SCRATCH_MNT=/mnt/xfs1
226                 SCRATCH_LOGDEV=/dev/hdc3
227                 ;;
228             lord)
229                 TEST_DIR=/xfs
230                 TEST_DEV=/dev/sda1
231                 SCRATCH_DEV=/dev/sda5
232                 SCRATCH_LOGDEV=/dev/sda6
233                 SCRATCH_MNT=/xfs1
234                 ;;
235             burst)
236                 TEST_DIR=/xfs
237                 TEST_DEV=/dev/hda3
238                 SCRATCH_DEV=/dev/hda7
239                 SCRATCH_MNT=/scratch
240                 ;;
241             lumpy)
242                 TEST_DEV=/dev/sdc5
243                 TEST_DIR=/mnt/scratch_0
244                 SCRATCH_DEV=/dev/sdc7
245                 SCRATCH_MNT=/mnt/scratch_2
246                 ;;
247             bongo)
248                 TEST_DEV=/dev/hda8
249                 TEST_DIR=/xfs1
250                 SCRATCH_DEV=/dev/hda9
251                 SCRATCH_MNT=/xfs2
252                 SCRATCH_LOGDEV=/dev/hda10
253                 SCRATCH_RTDEV=/dev/hda11
254                 ;;
255             surly)
256                 TEST_DEV=/dev/hda9
257                 TEST_DIR=/mnt/xfs1
258                 SCRATCH_DEV=/dev/hda8
259                 SCRATCH_MNT=/mnt/xfs0
260                 SCRATCH_LOGDEV=/dev/hda10
261                 TAPE_DEV=/dev/st0
262                 RMT_TAPE_DEV=fuzzy:/dev/st0
263                 RMT_IRIXTAPE_DEV=blub:/dev/tape
264                 RMT_TAPE_USER=guest
265                 ;;
266             permit)
267                 TEST_DEV=/dev/sdc1
268                 TEST_DIR=/mnt/xfs0
269                 SCRATCH_DEV=/dev/sdd1
270                 SCRATCH_MNT=/mnt/xfs1
271                 ;;
272             indra)
273                 TEST_DEV=/dev/sdb1
274                 TEST_DIR=/mnt/xfs0
275                 SCRATCH_DEV=/dev/sdb2
276                 SCRATCH_MNT=/mnt/xfs1
277                 ;;
278             usermode)
279                 TEST_DEV=/dev/ubd/1
280                 TEST_DIR=/mnt/test
281                 SCRATCH_DEV=/dev/ubd/2
282                 SCRATCH_MNT=/mnt/scratch
283                 SCRATCH_RTDEV=/dev/ubd/3
284                 SCRATCH_LOGDEV=/dev/ubd/4
285                 ;;
286             lite)
287                 TEST_DEV=/dev/sda1
288                 TEST_DIR=/mnt/sda1
289                 SCRATCH_DEV=/dev/sda2
290                 SCRATCH_MNT=/mnt/sda2
291                 SCRATCH_LOGDEV=/dev/sda3
292                 ;;
293             dmfnt2)
294                 TEST_DEV=/dev/sda6
295                 TEST_DIR=/mnt/test
296                 SCRATCH_DEV=/dev/sdc6
297                 SCRATCH_MNT=/mnt/scratch
298                 TAPE_DEV=/dev/st0
299                 RMT_TAPE_DEV=longhorn:/dev/tape
300                 # RMT_IRIXTAPE_DEV=longhorn:/dev/tape
301                 RMT_TAPE_USER=guest
302                 ;;
303             lab343)
304                 MODULAR=0
305                 EMAIL="hch@sgi.com"
306                 TEST_DEV=/dev/sdb1
307                 SCRATCH_DEV=/dev/sdb2
308                 SCRATCH_LOGDEV=/dev/sdb5
309                 SCRATCH_RTDEV=/dev/sdb6
310                 TEST_DIR=/qa/test
311                 SCRATCH_MNT=/qa/scratch
312                 ;;
313             *)
314                 echo "Error: need to define parameters for host $HOST"
315                 exit 1
316                 ;;
317         esac
318 }
319
320 if [ -f "$HOST_OPTIONS" ]; then
321     . ./"$HOST_OPTIONS"
322 else
323     known_hosts
324 fi
325
326 echo $TEST_DEV | grep -q ":" > /dev/null 2>&1
327 if [ ! -b "$TEST_DEV" -a "$?" != "0" ]
328 then
329     echo "common.config: Error: \$TEST_DEV ($TEST_DEV) is not a block device or a NFS filesystem"
330     exit 1
331 fi
332
333 if [ ! -d "$TEST_DIR" ]
334 then
335     echo "common.config: Error: \$TEST_DIR ($TEST_DIR) is not a directory"
336     exit 1
337 fi
338
339 echo $SCRATCH_DEV | grep -q ":" > /dev/null 2>&1
340 if [ ! -z "$SCRATCH_DEV" -a ! -b "$SCRATCH_DEV" -a "$?" != "0" ]
341 then
342     echo "common.config: Error: \$SCRATCH_DEV ($SCRATCH_DEV) is not a block device or a NFS filesystem"
343     exit 1
344 fi
345
346 if [ ! -z "$SCRATCH_MNT" -a ! -d "$SCRATCH_MNT" ]
347 then
348     echo "common.config: Error: \$SCRATCH_MNT ($SCRATCH_MNT) is not a directory"
349     exit 1
350 fi
351
352 _readlink()
353 {
354     if [ $# -ne 1 ]
355     then
356         echo "Usage: _readlink filename" 1>&2
357         exit 1
358     fi
359
360     perl -e "\$in=\"$1\";" -e '
361         $lnk = readlink($in);
362         if ($lnk =~ m!^/.*!) {
363           print "$lnk\n";
364         }
365         else {
366           chomp($dir = `dirname $in`);
367           print "$dir/$lnk\n";
368         }'
369 }
370
371 # if devfs is running expand the full /dev/.. pathname - this is what will be
372 # returned by utilities such as mount
373 [ -L "$TEST_DEV" ] && TEST_DEV=`_readlink $TEST_DEV`
374 [ -L "$SCRATCH_DEV" ] && SCRATCH_DEV=`_readlink $SCRATCH_DEV`
375 [ -L "$SCRATCH_LOGDEV" ] && SCRATCH_LOGDEV=`_readlink $SCRATCH_LOGDEV`
376 [ -L "$SCRATCH_RTDEV" ] && SCRATCH_RTDEV=`_readlink $SCRATCH_LOGDEV`
377
378 # make sure this script returns success
379 /bin/true